/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Libarchive.xs. Do not edit this file, edit Libarchive.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Archive/Ar/Libarchive.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include "perl_math_int64_types.h"
#define MATH_INT64_NATIVE_IF_AVAILABLE
#include "perl_math_int64.h"

#include <archive.h>
#include <archive_entry.h>

#if ARCHIVE_VERSION_NUMBER < 3000000
# if !defined(__LA_INT64_T)
#  if defined(_WIN32) && !defined(__CYGWIN__)
#   define __LA_INT64_T    __int64
#  else
#   if defined(_SCO_DS)
#    define __LA_INT64_T    long long
#   else
#    define __LA_INT64_T    int64_t
#   endif
#  endif
# endif
#endif

#define ARCHIVE_AR_UNDEF   0
#define ARCHIVE_AR_COMMON  1
#define ARCHIVE_AR_BSD     2
#define ARCHIVE_AR_GNU     3

#if ARCHIVE_VERSION_NUMBER < 3000000
#define archive_write_free(archive) archive_write_finish(archive)
#endif

#define _error(ar, message) {                                                   \
        if(ar->opt_warn)                                                        \
          warn("%s", message);                                                  \
        if(ar->error != NULL)                                                   \
          SvREFCNT_dec(ar->error);                                              \
        if(ar->longmess != NULL)                                                \
          SvREFCNT_dec(ar->longmess);                                           \
        ar->error = ar->longmess = SvREFCNT_inc(newSVpv(message,0));            \
      }

struct ar_entry;

struct ar {
  struct ar_entry *first;
  SV *callback;

  unsigned int opt_warn       : 2;
  unsigned int opt_chmod      : 1;
  unsigned int opt_same_perms : 1;
  unsigned int opt_chown      : 1;
  unsigned int opt_type       : 2;

  SV *error;
  SV *longmess;
  SV *opt_symbols;
};

struct ar_entry {
  struct archive_entry *entry;
  const char *data;
  size_t data_size;
  struct ar_entry *next;

  unsigned int is_symbol_table : 1;
};

static int ar_disk_options(struct ar *ar)
{
  int flags = ARCHIVE_EXTRACT_TIME;
  if(ar->opt_chown)
    flags |= ARCHIVE_EXTRACT_OWNER;
  if(ar->opt_same_perms)
    flags |= ARCHIVE_EXTRACT_PERM;
  return flags;
}

static void
ar_free_entry(struct ar_entry *entry)
{
  archive_entry_free(entry->entry);
  if(entry->data != NULL)
    Safefree(entry->data);
}

static void
ar_reset(struct ar *ar)
{
  struct ar_entry *entry, *old;

  if(ar->error != NULL)
    SvREFCNT_dec(ar->error);
  if(ar->longmess != NULL)
    SvREFCNT_dec(ar->longmess);

  ar->error    = NULL;
  ar->longmess = NULL;

  entry = ar->first;
  while(entry != NULL)
  {
    ar_free_entry(entry);
    old = entry;
    entry = entry->next;
    Safefree(old);
  }

  ar->first = NULL;

  ar->opt_type       = ARCHIVE_AR_UNDEF;
}

static struct ar_entry*
ar_find_by_name(struct ar *ar, const char *filename)
{
  struct ar_entry *entry;

  entry = ar->first;

  while(entry != NULL)
  {
    if(!strcmp(archive_entry_pathname(entry->entry), filename))
      return entry;
    entry = entry->next;
  }

  return NULL;
}

static int
ar_entry_extract(struct ar *ar, struct ar_entry *entry, struct archive *disk)
{
  int r;

  r = archive_write_header(disk, entry->entry);
  if(r != ARCHIVE_OK)
  {
    _error(ar,archive_error_string(disk));
  }
  else if(archive_entry_size(entry->entry) > 0)
  {
    r = archive_write_data_block(disk, entry->data, entry->data_size, 0);
    if(r != ARCHIVE_OK)
      _error(ar, archive_error_string(disk));
    if(r < ARCHIVE_WARN)
      return 0;
  }

  r = archive_write_finish_entry(disk);
  if(r != ARCHIVE_OK)
    _error(ar, archive_error_string(disk));

  if(r < ARCHIVE_WARN)
    return 0;
  else
    return 1;
}

static __LA_SSIZE_T
ar_read_callback(struct archive *archive, void *cd, const void **buffer)
{
  struct ar *ar = (struct ar *)cd;
  int count;
  __LA_INT64_T status;
  STRLEN len;
  SV *sv_buffer;

  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSViv(PTR2IV((void*)archive))));
  PUTBACK;

  count = call_sv(ar->callback, G_ARRAY);

  SPAGAIN;

  sv_buffer = SvRV(POPs);
  status = SvI64(POPs);
  if(status == ARCHIVE_OK)
  {
    *buffer = (void*) SvPV(sv_buffer, len);
  }

  PUTBACK;
  FREETMPS;
  LEAVE;

  if(status == ARCHIVE_OK)
    return len == 1 ? 0 : len;
  else
    return status;
}

static __LA_INT64_T
ar_write_callback(struct archive *archive, void *cd, const void *buffer, size_t length)
{
  struct ar *ar = (struct ar *)cd;
  int count;
  __LA_INT64_T status;

  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSViv(PTR2IV((void*)archive))));
  XPUSHs(sv_2mortal(newSVpvn(buffer, length)));
  PUTBACK;

  call_sv(ar->callback, G_SCALAR);

  SPAGAIN;

  status = SvI64(POPs);

  PUTBACK;
  FREETMPS;
  LEAVE;

  return status;
}

static int
ar_close_callback(struct archive *archive, void *client_data)
{
  return ARCHIVE_OK;
}

static __LA_INT64_T
ar_write_archive(struct archive *archive, struct ar *ar)
{
  int r;
  struct ar_entry *entry;
  int count;

  if(ar->opt_type == ARCHIVE_AR_GNU)
  {
    int size=0;

    /* calculate the size of the string table */
    for(entry = ar->first; entry != NULL; entry = entry->next)
    {
      if(entry->is_symbol_table)
        continue;
      int len = strlen(archive_entry_pathname(entry->entry));
      if(len > 15)
        size += len + 2;
    }

    /* if string table size is zero then we don't need  *
     * one.  Otherwise create the string table since    *
     * libarchive does not do that for us.              */
    if(size > 0)
    {
      struct archive_entry *table = archive_entry_new();
      archive_entry_set_pathname(table, "//");
      archive_entry_set_size(table, size);
      char buffer[size];
      int offset = 0;

      /* write the string table header */
      r = archive_write_header(archive, table);
      if(r < ARCHIVE_OK)
      {
        _error(ar, archive_error_string(archive));
        if(r != ARCHIVE_WARN)
        {
          archive_entry_free(table);
          return 0;
        }
      }

      /* construct the data section of the string table */
      for(entry = ar->first; entry != NULL; entry = entry->next)
      {
        const char *name;
        int len;
        name = archive_entry_pathname(entry->entry);
        len = strlen(name);

        if(len > 15)
        {
          memcpy(&buffer[offset], name, len);
          memcpy(&buffer[offset+len], "/\n", 2);
          offset += len+2;
        }
      }

      /* write the string table to the archive */
      r = archive_write_data(archive, buffer, size);
      archive_entry_free(table);

      if(r < ARCHIVE_OK)
      {
        _error(ar, archive_error_string(archive));
        if(r != ARCHIVE_WARN)
          return 0;
      }
    }
  }

  /* write each entry out one at a time */
  for(entry = ar->first; entry != NULL; entry = entry->next)
  {
    struct archive_entry *short_entry = NULL;

    if(entry->is_symbol_table)
    {
      short_entry = archive_entry_clone(entry->entry);
      archive_entry_copy_pathname(short_entry, "/");
    }

    if(ar->opt_type == ARCHIVE_AR_COMMON)
    {
      const char *name = archive_entry_pathname(entry->entry);
      int len = strlen(name);
      if(len > 15)
      {
        char buffer[16];
        short_entry = archive_entry_clone(entry->entry);
        strncpy(buffer, name, 15);
        buffer[15] = '\0';
        archive_entry_copy_pathname(short_entry, buffer);
      }
    }

    r = archive_write_header(archive, short_entry != NULL ? short_entry : entry->entry);
    if(r < ARCHIVE_OK)
    {
      _error(ar,archive_error_string(archive));
      if(r != ARCHIVE_WARN)
        return 0;
    }
    r = archive_write_data(archive, entry->data, entry->data_size);
    if(r < ARCHIVE_OK)
    {
      _error(ar,archive_error_string(archive));
      if(r != ARCHIVE_WARN)
        return 0;
    }

    if(short_entry != NULL)
      archive_entry_free(short_entry);
  }

#if ARCHIVE_VERSION_NUMBER < 3000000
  return archive_position_uncompressed(archive);
#else
  return archive_filter_bytes(archive, 0);
#endif
}

static __LA_INT64_T
ar_read_archive(struct archive *archive, struct ar *ar)
{
  struct archive_entry *entry;
  struct ar_entry *e=NULL, *next;
  int r;
  size_t size;
  off_t  offset;
  const char *name;
  int is_symbol_table;

  ar->opt_type = ARCHIVE_AR_COMMON;

  while(1)
  {
#if HAS_has_archive_read_next_header2
    entry = archive_entry_new();
    r = archive_read_next_header2(archive, entry);
#else
    struct archive_entry *tmp;
    r = archive_read_next_header(archive, &tmp);
    entry = archive_entry_clone(tmp);
#endif
    is_symbol_table = 0;


    if(r == ARCHIVE_OK || r == ARCHIVE_WARN)
    {
      name = archive_entry_pathname(entry);
      /* Filename of // means it has a GNU style string *
       * table                                          */
      if(!strcmp(name, "//"))
      {
        ar->opt_type = ARCHIVE_AR_GNU;
        continue;
      }

      if(!strcmp(name, "/"))
      {
        if(ar->opt_symbols == NULL)
          continue;
        archive_entry_copy_pathname(entry, SvPV_nolen(ar->opt_symbols));
        is_symbol_table = 1;
      }

      /* Otherwise rely on libarchive to determine *
       * archive type                              */
      if(ar->opt_type == ARCHIVE_AR_COMMON)
      {
        switch(archive_format(archive))
        {
          case ARCHIVE_FORMAT_AR_BSD:
            ar->opt_type = ARCHIVE_AR_BSD;
            break;
        }
      }
      if(r == ARCHIVE_WARN)
      {
        _error(ar,archive_error_string(archive));
      }
    }
    else if(r == ARCHIVE_EOF)
    {
#if ARCHIVE_VERSION_NUMBER < 3000000
      return archive_position_uncompressed(archive);
#else
      return archive_filter_bytes(archive, 0);
#endif
    }
    else
    {
      archive_entry_free(entry);
      _error(ar,archive_error_string(archive));
      ar_reset(ar);
      return 0;
    }

    Newx(next, 1, struct ar_entry);
    next->data_size = archive_entry_size(entry);
    Newx(next->data, next->data_size, char);

    r = archive_read_data(archive, (void*)next->data, next->data_size);
    next->is_symbol_table = is_symbol_table;

    if(r == ARCHIVE_WARN)
    {
      _error(ar,archive_error_string(archive));
    }
    else if(r < ARCHIVE_OK && r != ARCHIVE_EOF)
    {
      archive_entry_free(entry);
      _error(ar,archive_error_string(archive));
      Safefree(next->data);
      Safefree(next);
      return 0;
    }

    next->entry         = entry;
    next->next          = NULL;

    if(ar->first == NULL)
      ar->first = next;
    else
      e->next = next;
    e = next;
  }
}

#line 476 "lib/Archive/Ar/Libarchive.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 620 "lib/Archive/Ar/Libarchive.c"

XS_EUPXS(XS_Archive__Ar__Libarchive__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__new)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	struct ar *	RETVAL;
#line 474 "lib/Archive/Ar/Libarchive.xs"
    struct ar *self;
    Newx(self, 1, struct ar);
    self->first          = NULL;
    self->callback       = NULL;
    self->error          = NULL;
    self->longmess       = NULL;
    self->opt_symbols    = NULL;
    self->opt_warn       = 0;
    self->opt_chmod      = 1;  /* ignored */
    self->opt_same_perms = 1;  /* different: pp version this is true for root only */
    self->opt_chown      = 1;
    ar_reset(self);
    RETVAL = self;
#line 644 "lib/Archive/Ar/Libarchive.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
  sv_setref_pv(RETVALSV, "Archive::Ar::Libarchive", (void *) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_set_opt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_set_opt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, name, value");
    {
	struct ar *	self;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	SV *	value = ST(2)
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 496 "lib/Archive/Ar/Libarchive.xs"
    if(!strcmp(name, "warn"))
      RETVAL = self->opt_warn = SvIV(value);
    else if(!strcmp(name, "chmod"))
      RETVAL = self->opt_chmod = SvIV(value);
    else if(!strcmp(name, "same_perms"))
      RETVAL = self->opt_same_perms = SvIV(value);
    else if(!strcmp(name, "chown"))
      RETVAL = self->opt_chown = SvIV(value);
    else if(!strcmp(name, "type"))
      RETVAL = self->opt_type = SvIV(value);
    else if(!strcmp(name, "symbols"))
      self->opt_symbols = SvREFCNT_inc(value);  /*  TODO: make set_opt return void; maybe */
    else
      warn("unknown or unsupported option %s", name);
#line 691 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_get_opt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_get_opt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	struct ar *	self;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 518 "lib/Archive/Ar/Libarchive.xs"
    if(!strcmp(name, "warn"))
      RETVAL = self->opt_warn;
    else if(!strcmp(name, "chmod"))
      RETVAL = self->opt_chmod;
    else if(!strcmp(name, "same_perms"))
      RETVAL = self->opt_same_perms;
    else if(!strcmp(name, "chown"))
      RETVAL = self->opt_chown;
    else if(!strcmp(name, "type"))
    {
      if(self->opt_type == ARCHIVE_AR_UNDEF)
        XSRETURN_EMPTY;
      else
        RETVAL = self->opt_type;
    }
    else
      warn("unknown or unsupported option %s", name);
#line 735 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__set_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__set_error)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, message, longmess");
    {
	struct ar *	self;
	SV *	message = ST(1)
;
	SV *	longmess = ST(2)
;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 544 "lib/Archive/Ar/Libarchive.xs"
    if(self->error != NULL)
      SvREFCNT_dec(self->error);
    if(self->longmess != NULL)
      SvREFCNT_dec(self->longmess);
    self->error = SvREFCNT_inc(message);
    self->longmess = SvREFCNT_inc(longmess);
#line 768 "lib/Archive/Ar/Libarchive.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Ar__Libarchive_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_error)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	struct ar *	self;
	SV *	RETVAL;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 555 "lib/Archive/Ar/Libarchive.xs"
    if(self->error == NULL)
      XSRETURN_EMPTY;
    if(items >= 2 && SvTRUE(ST(1)))
      RETVAL = SvREFCNT_inc(self->longmess);
    else
      RETVAL = SvREFCNT_inc(self->error);
#line 796 "lib/Archive/Ar/Libarchive.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__read_from_filename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__read_from_filename)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 569 "lib/Archive/Ar/Libarchive.xs"
    struct archive *archive;
    int r;

    ar_reset(self);
    archive = archive_read_new();
    archive_read_support_format_ar(archive);

    r = archive_read_open_filename(archive, filename, 1024);
    if(r == ARCHIVE_OK || r == ARCHIVE_WARN)
    {
      if(r == ARCHIVE_WARN)
        _error(self, archive_error_string(archive));
      RETVAL = ar_read_archive(archive, self);
    }
    else
    {
      _error(self,archive_error_string(archive));
      RETVAL = 0;
    }
#if ARCHIVE_VERSION_NUMBER < 3000000
    archive_read_finish(archive);
#else
    archive_read_free(archive);
#endif
#line 847 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__read_from_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__read_from_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, callback");
    {
	struct ar *	self;
	SV *	callback = ST(1)
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 601 "lib/Archive/Ar/Libarchive.xs"
    struct archive *archive;
    int r;

    ar_reset(self);
    archive = archive_read_new();
    archive_read_support_format_ar(archive);

    self->callback = SvREFCNT_inc(callback);
    r = archive_read_open(archive, (void*)self, NULL, ar_read_callback, ar_close_callback);

    if(r == ARCHIVE_OK || r == ARCHIVE_WARN)
    {
      if(r == ARCHIVE_WARN)
        _error(self,archive_error_string(archive));
      RETVAL = ar_read_archive(archive, self);
    }
    else
    {
      _error(self,archive_error_string(archive));
      RETVAL = 0;
    }
#if ARCHIVE_VERSION_NUMBER < 3000000
    archive_read_finish(archive);
#else
    archive_read_free(archive);
#endif
    SvREFCNT_dec(callback);
    self->callback = NULL;
#line 902 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__write_to_filename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__write_to_filename)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 637 "lib/Archive/Ar/Libarchive.xs"
    struct archive *archive;
    int r;

    archive = archive_write_new();
    if(self->opt_type == ARCHIVE_AR_BSD)
      r = archive_write_set_format_ar_bsd(archive);
    else
      r = archive_write_set_format_ar_svr4(archive);
    if(r != ARCHIVE_OK)
      _error(self,archive_error_string(archive));
    r = archive_write_open_filename(archive, filename);
    if(r != ARCHIVE_OK)
      _error(self,archive_error_string(archive));
    if(r == ARCHIVE_OK || r == ARCHIVE_WARN)
      RETVAL = ar_write_archive(archive, self);
    else
      RETVAL = 0;
    archive_write_free(archive);
#line 947 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__write_to_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__write_to_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, callback");
    {
	struct ar *	self;
	SV *	callback = ST(1)
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 663 "lib/Archive/Ar/Libarchive.xs"
    struct archive *archive;
    int r;

    self->callback = SvREFCNT_inc(callback);

    archive = archive_write_new();
    if(self->opt_type == ARCHIVE_AR_BSD)
      r = archive_write_set_format_ar_bsd(archive);
    else
      r = archive_write_set_format_ar_svr4(archive);
    if(r != ARCHIVE_OK)
      _error(self,archive_error_string(archive));
    archive_write_set_bytes_in_last_block(archive, 1);
    r = archive_write_open(archive, (void*)self, NULL, ar_write_callback, ar_close_callback);
    if(r != ARCHIVE_OK)
      _error(self,archive_error_string(archive));
    if(r == ARCHIVE_OK || r == ARCHIVE_WARN)
      RETVAL = ar_write_archive(archive, self);
    else
      RETVAL = 0;
    archive_write_free(archive);
    SvREFCNT_dec(callback);
    self->callback = NULL;
#line 997 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pathname");
    {
	struct ar *	self;
	const char *	pathname = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 694 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry **entry;
    entry = &(self->first);

    RETVAL = 0;

    while(1)
    {
      if(!strcmp(archive_entry_pathname((*entry)->entry),pathname))
      {
        ar_free_entry(*entry);
        *entry = (*entry)->next;
        RETVAL = 1;
        break;
      }

      if((*entry)->next == NULL)
        break;

      entry = &((*entry)->next);
    }

#line 1045 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__add_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__add_data)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "self, filename, data, uid, gid, date, mode");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	SV *	data = ST(2)
;
	__LA_INT64_T        uid = SvI64(ST(3))
;
	__LA_INT64_T        gid = SvI64(ST(4))
;
	time_t	date = (time_t)SvNV(ST(5))
;
	int	mode = (int)SvIV(ST(6))
;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 728 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry **entry;
    char *buffer;

    entry = &(self->first);

    while(*entry != NULL)
    {
      entry = &((*entry)->next);
    }

    Newx((*entry), 1, struct ar_entry);

    (*entry)->entry = archive_entry_new();
    archive_entry_set_pathname((*entry)->entry, filename);
    archive_entry_set_uid((*entry)->entry, uid);
    archive_entry_set_gid((*entry)->entry, gid);
    archive_entry_set_mtime((*entry)->entry, date, date);
    archive_entry_set_mode((*entry)->entry, mode);

    (*entry)->next          = NULL;
    (*entry)->is_symbol_table = 0;
    if(self->opt_symbols != NULL && !strcmp(SvPV_nolen(self->opt_symbols), filename))
      (*entry)->is_symbol_table = 1;

    buffer = SvPV(data, (*entry)->data_size);
    archive_entry_set_size((*entry)->entry, (*entry)->data_size);

    Newx((*entry)->data, (*entry)->data_size, char);
    Copy(buffer, (*entry)->data, (*entry)->data_size, char);
#line 1109 "lib/Archive/Ar/Libarchive.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Ar__Libarchive__list_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__list_files)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct ar *	self;
	SV *	RETVAL;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 763 "lib/Archive/Ar/Libarchive.xs"
    AV *list;
    struct ar_entry *entry;
    const char *pathname;

    list = newAV();

    for(entry = self->first; entry != NULL; entry = entry->next)
    {
      pathname = archive_entry_pathname(entry->entry);
      av_push(list, newSVpv(pathname, strlen(pathname)));
    }

    RETVAL = newRV_noinc((SV*)list);
#line 1144 "lib/Archive/Ar/Libarchive.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct ar *	self;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 783 "lib/Archive/Ar/Libarchive.xs"
    ar_reset(self);
    Safefree(self);
#line 1169 "lib/Archive/Ar/Libarchive.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Ar__Libarchive_get_content); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_get_content)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 791 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    HV *hv;
    int found;

    entry = ar_find_by_name(self, filename);

    if(entry != NULL)
    {
      hv = newHV();
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-value"
      hv_store(hv, "name", 4, newSVpv(filename, strlen(filename)),         0);
      hv_store(hv, "date", 4, newSVi64(archive_entry_mtime(entry->entry)), 0);
      hv_store(hv, "uid",  3, newSVi64(archive_entry_uid(entry->entry)),   0);
      hv_store(hv, "gid",  3, newSVi64(archive_entry_gid(entry->entry)),   0);
      hv_store(hv, "mode", 4, newSViv(archive_entry_mode(entry->entry)),   0);
      hv_store(hv, "size", 4, newSViv(entry->data_size),                   0);
      hv_store(hv, "data", 4, newSVpv(entry->data, entry->data_size),      0);
#pragma clang diagnostic pop
      RETVAL = newRV_noinc((SV*)hv);

    }
    else
    {
      XSRETURN_EMPTY;
    }
#line 1219 "lib/Archive/Ar/Libarchive.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_get_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_get_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 825 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    entry = ar_find_by_name(self, filename);
    if(entry == NULL)
      XSRETURN_EMPTY;
    RETVAL = newSVpv(entry->data, entry->data_size);
#line 1250 "lib/Archive/Ar/Libarchive.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_rename)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, old, new");
    {
	struct ar *	self;
	const char *	old = (const char *)SvPV_nolen(ST(1))
;
	const char *	new = (const char *)SvPV_nolen(ST(2))
;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 840 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    entry = ar_find_by_name(self, old);
    if(entry != NULL)
      archive_entry_set_pathname(entry->entry, new);
#line 1281 "lib/Archive/Ar/Libarchive.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Ar__Libarchive_extract); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_extract)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct ar *	self;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 849 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    struct archive *disk;
    int ok = 1;

    entry = self->first;

    disk = archive_write_disk_new();
    archive_write_disk_set_options(disk, ar_disk_options(self));
    archive_write_disk_set_standard_lookup(disk);

    while(entry != NULL)
    {
      if(ar_entry_extract(self, entry, disk) == 0)
      {
        ok = 0;
        break;
      }
      entry = entry->next;
    }

    archive_write_close(disk);
    archive_write_free(disk);

    if(ok)
      RETVAL = 1;
    else
      XSRETURN_EMPTY;
#line 1331 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_extract_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_extract_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 884 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    struct archive *disk;
    int ok;

    entry = ar_find_by_name(self, filename);

    if(entry == NULL)
      XSRETURN_EMPTY;

    disk = archive_write_disk_new();
    archive_write_disk_set_options(disk, ar_disk_options(self));
    archive_write_disk_set_standard_lookup(disk);

    ok = ar_entry_extract(self, entry, disk);

    archive_write_close(disk);
    archive_write_free(disk);

    if(ok)
      RETVAL = 1;
    else
      XSRETURN_EMPTY;

#line 1381 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct ar *	self;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 915 "lib/Archive/Ar/Libarchive.xs"
    RETVAL = self->opt_type;
#line 1407 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_contains_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_contains_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, filename");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 925 "lib/Archive/Ar/Libarchive.xs"
    if(ar_find_by_name(self, filename))
      RETVAL = 1;
    else
      XSRETURN_EMPTY;
#line 1438 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct ar *	self;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 937 "lib/Archive/Ar/Libarchive.xs"
    ar_reset(self);
#line 1462 "lib/Archive/Ar/Libarchive.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Archive__Ar__Libarchive__chmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__chmod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, filename, mode");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 946 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    entry = ar_find_by_name(self, filename);
    if(entry != NULL)
    {
      archive_entry_set_mode(entry->entry, mode);
      RETVAL = 1;
    }
    else
    {
      XSRETURN_EMPTY;
    }
#line 1500 "lib/Archive/Ar/Libarchive.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__chown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__chown)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, filename, uid, gid");
    {
	struct ar *	self;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	uid = (int)SvIV(ST(2))
;
	SV *	gid = ST(3)
;
	int	RETVAL;
	dXSTARG;

  if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Archive::Ar::Libarchive"))
    self = INT2PTR(struct ar *, SvIV((SV *) SvRV(ST(0))));
  else
    Perl_croak(aTHX_ "self is not of type Archive::Ar::Libarchive")
;
#line 968 "lib/Archive/Ar/Libarchive.xs"
    struct ar_entry *entry;
    entry = ar_find_by_name(self, filename);
    if(entry != NULL)
    {
      if(uid >= 0)
        archive_entry_set_uid(entry->entry, uid);
      if(SvOK(gid) && SvIV(gid) >= 0)
      {
        archive_entry_set_gid(entry->entry, SvIV(gid));
      }
    }
    else
    {
      XSRETURN_EMPTY;
    }
#line 1546 "lib/Archive/Ar/Libarchive.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Archive__Ar__Libarchive__libarchive_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Archive__Ar__Libarchive__libarchive_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 987 "lib/Archive/Ar/Libarchive.xs"
    RETVAL = ARCHIVE_VERSION_STRING;
#line 1563 "lib/Archive/Ar/Libarchive.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Archive__Ar__Libarchive); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Archive__Ar__Libarchive)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Archive::Ar::Libarchive::_new", XS_Archive__Ar__Libarchive__new);
        newXS_deffile("Archive::Ar::Libarchive::set_opt", XS_Archive__Ar__Libarchive_set_opt);
        newXS_deffile("Archive::Ar::Libarchive::get_opt", XS_Archive__Ar__Libarchive_get_opt);
        newXS_deffile("Archive::Ar::Libarchive::_set_error", XS_Archive__Ar__Libarchive__set_error);
        newXS_deffile("Archive::Ar::Libarchive::error", XS_Archive__Ar__Libarchive_error);
        newXS_deffile("Archive::Ar::Libarchive::_read_from_filename", XS_Archive__Ar__Libarchive__read_from_filename);
        newXS_deffile("Archive::Ar::Libarchive::_read_from_callback", XS_Archive__Ar__Libarchive__read_from_callback);
        newXS_deffile("Archive::Ar::Libarchive::_write_to_filename", XS_Archive__Ar__Libarchive__write_to_filename);
        newXS_deffile("Archive::Ar::Libarchive::_write_to_callback", XS_Archive__Ar__Libarchive__write_to_callback);
        newXS_deffile("Archive::Ar::Libarchive::_remove", XS_Archive__Ar__Libarchive__remove);
        newXS_deffile("Archive::Ar::Libarchive::_add_data", XS_Archive__Ar__Libarchive__add_data);
        newXS_deffile("Archive::Ar::Libarchive::_list_files", XS_Archive__Ar__Libarchive__list_files);
        newXS_deffile("Archive::Ar::Libarchive::DESTROY", XS_Archive__Ar__Libarchive_DESTROY);
        newXS_deffile("Archive::Ar::Libarchive::get_content", XS_Archive__Ar__Libarchive_get_content);
        newXS_deffile("Archive::Ar::Libarchive::get_data", XS_Archive__Ar__Libarchive_get_data);
        newXS_deffile("Archive::Ar::Libarchive::rename", XS_Archive__Ar__Libarchive_rename);
        newXS_deffile("Archive::Ar::Libarchive::extract", XS_Archive__Ar__Libarchive_extract);
        newXS_deffile("Archive::Ar::Libarchive::extract_file", XS_Archive__Ar__Libarchive_extract_file);
        newXS_deffile("Archive::Ar::Libarchive::type", XS_Archive__Ar__Libarchive_type);
        newXS_deffile("Archive::Ar::Libarchive::contains_file", XS_Archive__Ar__Libarchive_contains_file);
        newXS_deffile("Archive::Ar::Libarchive::clear", XS_Archive__Ar__Libarchive_clear);
        newXS_deffile("Archive::Ar::Libarchive::_chmod", XS_Archive__Ar__Libarchive__chmod);
        newXS_deffile("Archive::Ar::Libarchive::_chown", XS_Archive__Ar__Libarchive__chown);
        newXS_deffile("Archive::Ar::Libarchive::_libarchive_version", XS_Archive__Ar__Libarchive__libarchive_version);

    /* Initialisation Section */

#line 469 "lib/Archive/Ar/Libarchive.xs"
     PERL_MATH_INT64_LOAD_OR_CROAK;

#line 1629 "lib/Archive/Ar/Libarchive.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
